Package: rim
Type: Package
Title: Interface to 'Maxima', Enabling Symbolic Computation
Version: 0.6.4
Date: 2023-08-24
Authors@R: c(
    person("Eric", "Stemmler", email = "stemmler.eric@gmail.com", role = c("aut", "cre")),
    person("Kseniia", "Shumelchyk", email = "shumelchyk@gmail.com", role = c("aut")),
    person("Hans W.", "Borchers", email = "hwborchers@googlemail.com", role = c("aut")))
Description: An interface to the powerful and fairly complete computer algebra system 'Maxima'.
    It can be used to start and control 'Maxima' from within R by entering 'Maxima' commands. 
    Results from 'Maxima' can be parsed and evaluated in R. 
    It facilitates outputting results from 'Maxima' in 'LaTeX' and 'MathML'. 
    2D and 3D plots can be displayed directly. 
    This package also registers a 'knitr'-engine enabling 'Maxima' code chunks 
    to be written in 'RMarkdown' documents.
URL: https://rcst.github.io/rim/
BugReports: https://github.com/rcst/rim/issues
SystemRequirements: Maxima (https://sourceforge.net/projects/maxima/,
        tested with versions 5.42.0 - 5.46.0), needs to be on PATH
License: GPL (>= 3)
Imports: methods, Rcpp, R6, knitr, GlobalOptions
LinkingTo: Rcpp
RoxygenNote: 7.2.3
Suggests: testthat (>= 3.0.0), rmarkdown
Config/testthat/edition: 3
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2023-08-24 11:33:13 UTC; eric
Author: Eric Stemmler [aut, cre],
  Kseniia Shumelchyk [aut],
  Hans W. Borchers [aut]
Maintainer: Eric Stemmler <stemmler.eric@gmail.com>
Repository: CRAN
Date/Publication: 2023-08-24 12:00:02 UTC
Built: R 4.4.1; x86_64-apple-darwin24.0.0; 2024-09-27 22:41:04 UTC; unix

test_that("parsing and evaluation of parsed results works", {
  if(!maxima.env$maxima$isInstalled()) 
    skip("Maxima not installed")

  t1 <- maxima.get("integrate(1/(1 - x^3), x);")
  p1 <- maxima.eval(t1, code = TRUE, envir = list(x = 1:5))
  expect_s3_class(t1, "maxima")
  expect_type(t1, "list")
  expect_equal(nchar(paste0(deparse(attr(t1, "parsed")), collapse = "")), 130L)
  expect_length(p1, 5)
  expect_equal(p1[1], Inf)
  expect_false(attr(t1, "suppressed"))

  t2 <- maxima.get("2+2$")
  p2 <- maxima.eval(t2, code = TRUE)
  expect_s3_class(t2, "maxima")
  expect_type(t2, "list")
  expect_true(is.na(nchar(attr(t2, "parsed"))))
  expect_true(is.na(p2))
  expect_length(p2, 1)
  expect_true(attr(t2, "suppressed"))

  p3 <- maxima.eval("integrate(x, x);", code = TRUE, list(x = 1))
  expect_length(p3, 1)
  expect_gte(nchar(deparse(attr(p3, "maxima"))), 18L)

  p4 <- maxima.eval("x^2+1;", code = FALSE, list(x = 3))
  expect_null(attr(p4, "maxima"))
})

test_that("warnings are forwarded", {
  if(!maxima.env$maxima$isInstalled()) 
    skip("Maxima not installed")
  if(maxima.version() < "5.43" | maxima.version() >= "5.45.1")
    skip(paste("No warnings to be tested under Maxima", maxima.version(), "\n"))

  maxima.get("float2bf: false$")
  maxima.get("x: float(%pi)$")
  expect_warning(maxima.get("bfloat(x);"))
  expect_warning(maxima.eval("sum(1/x^2, x, 1, 10000);"))
})

test_that("execution returns formatted strings", {
  if(!maxima.env$maxima$isInstalled()) 
    skip("Maxima not installed")

  to <- maxima.get("jacobian( [alpha / (alpha + beta), 1 / sqrt(alpha + beta)], [alpha, beta] );")
  expect_s3_class(to, "maxima")
  expect_type(to, "list")
  expect_match(attr(to, "input.label"), "^%\\i[[:digit::]]*$")
  expect_match(attr(to, "output.label"), "^\\%o[[:digit::]]*$")
  expect_equal(attr(to, "command"), "jacobian( [alpha / (alpha + beta), 1 / sqrt(alpha + beta)], [alpha, beta] );")
  expect_true(!attr(to, "suppressed"))

  to <- maxima.get("2+2$")
  expect_s3_class(to, "maxima")
  expect_type(to, "list")
  expect_length(to, 0L)
  expect_match(attr(to, "input.label"), "^%\\i[[:digit::]]*$")
  expect_match(attr(to, "output.label"), "^\\%o[[:digit::]]*$")
  expect_equal(attr(to, "command"), "2+2$")
  expect_true(attr(to, "suppressed"))
})

test_that("maxima knitr engine works", {
  if(!maxima.env$maxima$isInstalled()) 
    skip("Maxima not installed")
  # if(.Platform$OS.type == "windows")
  #   skip("Engine test takes too long under windows")

  fr <- system.file("extdata", c("test.Rmd", "result.md"),
		    package = "rim", mustWork = TRUE)
  fo <- paste0(dirname(fr[1]), "/test.md")

  result <- readLines(con = fr[2])
  suppressWarnings(knit(input = fr[1], output = fo, quiet = TRUE))
  test <- readLines(con = fo)

  # expect_match(digest::digest(readLines(fo), "sha256"), hash)
  expect_equal(object = test, expected = result)

  # clean up
  file.remove(fo)

  # gnuplot files
  td <- dirname(dirname(tempfile()))
  rf <- list.files(path = td, 
		   pattern = "(?:maxout|data)[[:digit:]]*\\.gnuplot", 
		   full.names = TRUE)

  file.remove(rf)
})

test_that("ask prompts are returned", {
  if(!maxima.env$maxima$isInstalled()) 
    skip("Maxima not installed")
  expect_match(maxima.get("integrate(x^n,x)"), "Is n equal to -1?")

  to <- maxima.get("y;")
  expect_s3_class(to, "maxima")
  expect_type(to, "list")
  expect_match(attr(to, "input.label"), "^%\\i[[:digit::]]*$")
  expect_match(attr(to, "output.label"), "^\\%o[[:digit::]]*$")
  expect_equal(attr(to, "command"), "y;")
  expect_true(!attr(to, "suppressed"))
  # expect_match(maxima.get("y;"), "^[[:space:]|[:print:]]*$")

  expect_length(to$wtl$linear, 1L)
  expect_length(to$wtl$ascii, 1L)
  expect_length(to$wtl$latex, 1L)
  expect_length(to$wtl$mathml, 3L)

  expect_length(to$wol$linear, 1L)
  expect_length(to$wol$ascii, 1L)
  expect_length(to$wol$latex, 1L)
  expect_length(to$wol$mathml, 2L)
})

test_that("maxima.apropos returns exact result", {
  if(!maxima.env$maxima$isInstalled()) 
    skip("Maxima not installed") 

  to <- maxima.apropos("int")

  expect_s3_class(to, "maxima")
  expect_type(to, "list")
  expect_match(attr(to, "input.label"), "^%\\i[[:digit::]]*$")
  expect_match(attr(to, "output.label"), "^\\%o[[:digit::]]*$")
  expect_equal(attr(to, "command"), "apropos(\"int\");")
  expect_true(!attr(to, "suppressed"))

  expect_named(to, expected = c("wtl", "wol"))
  expect_named(to$wtl, expected = c("linear", "ascii", "latex", "inline", "mathml"))
  expect_named(to$wol, expected = c("linear", "ascii", "latex", "inline", "mathml", "rstr"))
  
  expect_gt(length(to$wtl$linear), 10L)
  expect_gt(length(to$wtl$ascii), 10L)
  expect_length(to$wtl$latex, 1L)
  expect_gt(length(to$wtl$mathml), 10L)

  expect_gt(length(to$wol$linear), 10L)
  expect_gt(length(to$wol$ascii), 10L)
  expect_length(to$wol$latex, 1L)
  expect_gt(length(to$wol$mathml), 10L)
})

---
title: "knitr engine test page"
output: html_document
---

```{r}
maxima.options(engine.format = "latex", 
	       engine.label = TRUE,
	       inline.format = "inline", 
	       inline.label = FALSE)
```

```{maxima}
L: sqrt(1 - 1/R^2);
assume(R > 0);
'integrate(x, x, 0, L) = integrate(x, x, 0, L);
```

```{maxima}
'L = L;
'integrate(x, x, 0, 'L) = integrate(x, x, 0, L);
```

This is an inline test: `r maxima.inline("'L = L;")`.


```{maxima}
sqrt(3/4);
```

```{maxima, output.var = "moo"}
f(x) := e^(x^2)$
diff(f(x), x);
```

```{maxima}
%;
```

```{maxima, output.var = "moo"}
log(%o1);
```

```{r}
moo
eval(moo[[1]], list(R = 12))
```

# Plots

```{maxima, fig.cap = "plot2d()", fig.align="center", fig.show='hide'}
r: (exp(cos(t))-2*cos(4*t)-sin(t/12)^5)$
plot2d([parametric, r*sin(t), r*cos(t), [t,-8*%pi,8*%pi]]);
```

```{maxima, fig.cap = "plot3d()", fig.align="center", fig.show='hide'}
plot3d(log (x^2*y^2), [x, -2, 2], [y, -2, 2],[grid, 29, 29],
       [palette, [gradient, red, orange, yellow, green]],
       color_bar, [xtics, 1], [ytics, 1], [ztics, 4],
       [color_bar_tics, 4]);
```

```{maxima, fig.cap = "draw()", fig.align="center", fig.show='hide'}
example1:
  gr3d (title          = "Controlling color range",
        enhanced3d     = true,
        color          = green,
        cbrange        = [-3,10],
        explicit(x^2+y^2, x,-2,2,y,-2,2)) $

example2:
  gr3d (title          = "Playing with tics in colorbox",
        enhanced3d     = true,
        color          = green,
        cbtics         = {["High",10],["Medium",05],["Low",0]},
        cbrange = [0, 10],
        explicit(x^2+y^2, x,-2,2,y,-2,2))$

example3:
  gr3d (title      = "Logarithmic scale to colors",
        enhanced3d = true,
        color      = green,
        logcb      = true,
        logz       = true,
        palette    = [-15,24,-9],
        explicit(exp(x^2-y^2), x,-2,2,y,-2,2))$

draw(
  dimensions = [500,1500],
  example1, example2, example3)$
```

```{maxima, fig.cap = "draw2d()", fig.align="center", fig.show='hide'}
draw2d(
  dimensions = [1000, 1000],
  proportional_axes = xy,
  fill_color        = sea_green,
  color             = aquamarine,
  line_width        = 6,
  ellipse(7,6,2,3,0,360))$
``` 

```{maxima, fig.cap = "draw3d()", fig.align="center", fig.show='hide'}
draw3d(
   dimensions = [1000, 1000],
   surface_hide      = true,
   axis_3d           = false,
   proportional_axes = xyz,
 
   color             = blue,
   cylindrical(z,z,-2,2,a,0,2*%pi), 
 
   color            = brown,
   cylindrical(3,z,-2,2,az,0,%pi),
 
   color            = green,
   cylindrical(sqrt(25-z^2),z,-5,5,a,0,%pi))$
```


```{r, warning=FALSE, results="markup"}
pft <- list.files(pattern = "(?:plot|draw)(2d|3d)?-[[:print:]]{6}\\.png", full.names = TRUE)

if(length(pft) == 5L)  {
  paste0("OK")
} else {
  paste0("Error: Unexpected number of Maxima plots: ", 
         paste0(pft, collapse = ", "))
}

if(length(pft)) {
  if(all(as.logical(file.size(pft)))) {
    paste0("OK")
  }
  else {
    errfiles <- pft[file.size(pft) == 0]
    paste0("Error: Maxima plot file(s) ", paste0(errfiles, collapse = ", "),
           "are empty.")
  }
}
```

# Normal Distribution

```{maxima}
area(dist) := integrate(dist, x, minf, inf)$
mean(dist) := area(dist*x)$
EX2(dist) := area(dist*x^2)$
variance(dist) := EX2(dist) - mean(dist)^2$
mgf(dist) := area(dist*%e^(x*t))$
```

```{maxima}
normal(x) := 
      (2*%pi*sigma^2)^(-1/2) * 
      exp(-(x-mu)^2/(2*sigma^2));

assume(sigma > 0)$

area(normal(x));
mean(normal(x));
variance(normal(x));
mgf(normal(x));
```

# Laplace Distribution

```{maxima}
laplace(x) := (2*b)^-1 * exp(-abs(x - mu)/b);

load("abs_integrate")$

assume(b > 0)$

area(laplace(x))$
mean(laplace(x))$
variance(laplace(x))$
```

# Exponential Distribution

```{maxima}
expo(x) := unit_step(x) * lambda * exp(-lambda * x);

assume(lambda > 0)$

area(expo(x));
mean(expo(x));
variance(expo(x));
```

# Matrices

```{maxima}
m: matrix([0, 1, a], [1, 0, 1], [1, 1, 0]);
transpose(m);
determinant(m);
f: invert(m), detout;
m . f;
expand(%);
factor(%);
```

# If-then-else

```{maxima}
x: 1234;
y: 2345;
```

```{maxima}
if x > y
  then x
  else y;
```

---
title: "knitr engine test page"
output: html_document
---

maxima.options(engine.format = "latex", 
	       engine.label = TRUE,
	       inline.format = "inline", 
	       inline.label = FALSE)

(%i1) L: sqrt(1 - 1/R^2);$$\mathtt{(\textit{\%o}_{1})}\quad \sqrt{1-\frac{1}{R^2}}$$
(%i2) assume(R > 0);$$\mathtt{(\textit{\%o}_{2})}\quad \left[ R>0 \right] $$
(%i3) 'integrate(x, x, 0, L) = integrate(x, x, 0, L);$$\mathtt{(\textit{\%o}_{3})}\quad \int_{0}^{\sqrt{1-\frac{1}{R^2}}}{x\;dx}=\frac{R^2-1}{2\,R^2}$$


(%i4) 'L = L;$$\mathtt{(\textit{\%o}_{4})}\quad L=\sqrt{1-\frac{1}{R^2}}$$
(%i5) 'integrate(x, x, 0, 'L) = integrate(x, x, 0, L);$$\mathtt{(\textit{\%o}_{5})}\quad \int_{0}^{L}{x\;dx}=\frac{R^2-1}{2\,R^2}$$


This is an inline test: $L=\sqrt{1-\frac{1}{R^2}}$
.


(%i7) sqrt(3/4);$$\mathtt{(\textit{\%o}_{7})}\quad \frac{\sqrt{3}}{2}$$


(%i8) f(x) := e^(x^2)$(%i9) diff(f(x), x);$$\mathtt{(\textit{\%o}_{9})}\quad 2\,e^{x^2}\,\log e\,x$$


(%i10) %;$$\mathtt{(\textit{\%o}_{10})}\quad 2\,e^{x^2}\,\log e\,x$$


(%i11) log(%o1);$$\mathtt{(\textit{\%o}_{11})}\quad \frac{\log \left(1-\frac{1}{R^2}\right)}{2}$$


moo## $o11
## ((1L/2L) * log((1L + (-1L * (R^-2L)))))
eval(moo[[1]], list(R = 12))## [1] -0.003484335


# Plots

(%i12) r: (exp(cos(t))-2*cos(4*t)-sin(t/12)^5)$(%i13) plot2d([parametric, r*sin(t), r*cos(t), [t,-8*%pi,8*%pi]]);

(%i14) plot3d(log (x^2*y^2), [x, -2, 2], [y, -2, 2],[grid, 29, 29],
       [palette, [gradient, red, orange, yellow, green]],
       color_bar, [xtics, 1], [ytics, 1], [ztics, 4],
       [color_bar_tics, 4]);

(%i15) example1:
  gr3d (title          = "Controlling color range",
        enhanced3d     = true,
        color          = green,
        cbrange        = [-3,10],
        explicit(x^2+y^2, x,-2,2,y,-2,2)) $(%i16) example2:
  gr3d (title          = "Playing with tics in colorbox",
        enhanced3d     = true,
        color          = green,
        cbtics         = {["High",10],["Medium",05],["Low",0]},
        cbrange = [0, 10],
        explicit(x^2+y^2, x,-2,2,y,-2,2))$(%i17) example3:
  gr3d (title      = "Logarithmic scale to colors",
        enhanced3d = true,
        color      = green,
        logcb      = true,
        logz       = true,
        palette    = [-15,24,-9],
        explicit(exp(x^2-y^2), x,-2,2,y,-2,2))$(%i18) draw(
  dimensions = [500,1500],
  example1, example2, example3);

(%i19) draw2d(
  dimensions = [1000, 1000],
  proportional_axes = xy,
  fill_color        = sea_green,
  color             = aquamarine,
  line_width        = 6,
  ellipse(7,6,2,3,0,360));

(%i20) draw3d(
   dimensions = [1000, 1000],
   surface_hide      = true,
   axis_3d           = false,
   proportional_axes = xyz,
 
   color             = blue,
   cylindrical(z,z,-2,2,a,0,2*%pi), 
 
   color            = brown,
   cylindrical(3,z,-2,2,az,0,%pi),
 
   color            = green,
   cylindrical(sqrt(25-z^2),z,-5,5,a,0,%pi));


pft <- list.files(pattern = "(?:plot|draw)(2d|3d)?-[[:print:]]{6}\\.png", full.names = TRUE)if(length(pft) == 5L)  {
  paste0("OK")
} else {
  paste0("Error: Unexpected number of Maxima plots: ", 
         paste0(pft, collapse = ", "))
}## [1] "OK"
if(length(pft)) {
  if(all(as.logical(file.size(pft)))) {
    paste0("OK")
  }
  else {
    errfiles <- pft[file.size(pft) == 0]
    paste0("Error: Maxima plot file(s) ", paste0(errfiles, collapse = ", "),
           "are empty.")
  }
}## [1] "OK"


# Normal Distribution

(%i21) area(dist) := integrate(dist, x, minf, inf)$(%i22) mean(dist) := area(dist*x)$(%i23) EX2(dist) := area(dist*x^2)$(%i24) variance(dist) := EX2(dist) - mean(dist)^2$(%i25) mgf(dist) := area(dist*%e^(x*t))$

(%i26) normal(x) := 
      (2*%pi*sigma^2)^(-1/2) * 
      exp(-(x-mu)^2/(2*sigma^2));$$\mathtt{(\textit{\%o}_{26})}\quad \textit{normal}\left(x\right):=\left(2\,\pi\,\sigma^2\right)^{\frac{-1}{2}}\,\exp \left(\frac{-\left(x-\mu\right)^2}{2\,\sigma^2}\right)$$
(%i27) assume(sigma > 0)$(%i28) area(normal(x));$$\mathtt{(\textit{\%o}_{28})}\quad 1$$
(%i29) mean(normal(x));$$\mathtt{(\textit{\%o}_{29})}\quad \mu$$
(%i30) variance(normal(x));$$\mathtt{(\textit{\%o}_{30})}\quad \frac{2^{\frac{3}{2}}\,\sqrt{\pi}\,\sigma^3+2^{\frac{3}{2}}\,\sqrt{\pi}\,\mu^2\,\sigma}{2^{\frac{3}{2}}\,\sqrt{\pi}\,\sigma}-\mu^2$$
(%i31) mgf(normal(x));$$\mathtt{(\textit{\%o}_{31})}\quad e^{\frac{\sigma^2\,t^2+2\,\mu\,t}{2}}$$


# Laplace Distribution

(%i32) laplace(x) := (2*b)^-1 * exp(-abs(x - mu)/b);$$\mathtt{(\textit{\%o}_{32})}\quad \textit{laplace}\left(x\right):=\left(2\,b\right)^ {- 1 }\,\exp \left(\frac{-\left| x-\mu\right| }{b}\right)$$
(%i33) load("abs_integrate")$(%i34) assume(b > 0)$(%i35) area(laplace(x))$(%i36) mean(laplace(x))$(%i37) variance(laplace(x))$

# Exponential Distribution

(%i38) expo(x) := unit_step(x) * lambda * exp(-lambda * x);$$\mathtt{(\textit{\%o}_{38})}\quad \textit{expo}\left(x\right):=\textit{unit\_step}\left(x\right)\,\lambda\,\exp \left(\left(-\lambda\right)\,x\right)$$
(%i39) assume(lambda > 0)$(%i40) area(expo(x));$$\mathtt{(\textit{\%o}_{40})}\quad 1$$
(%i41) mean(expo(x));$$\mathtt{(\textit{\%o}_{41})}\quad \frac{1}{\lambda}$$
(%i42) variance(expo(x));$$\mathtt{(\textit{\%o}_{42})}\quad \frac{1}{\lambda^2}$$


# Matrices

(%i43) m: matrix([0, 1, a], [1, 0, 1], [1, 1, 0]);$$\mathtt{(\textit{\%o}_{43})}\quad \begin{pmatrix}0 & 1 & a \\ 1 & 0 & 1 \\ 1 & 1 & 0 \\ \end{pmatrix}$$
(%i44) transpose(m);$$\mathtt{(\textit{\%o}_{44})}\quad \begin{pmatrix}0 & 1 & 1 \\ 1 & 0 & 1 \\ a & 1 & 0 \\ \end{pmatrix}$$
(%i45) determinant(m);$$\mathtt{(\textit{\%o}_{45})}\quad a+1$$
(%i46) f: invert(m), detout;$$\mathtt{(\textit{\%o}_{46})}\quad \frac{\begin{pmatrix}-1 & a & 1 \\ 1 & -a & a \\ 1 & 1 & -1 \\ \end{pmatrix}}{a+1}$$
(%i47) m . f;$$\mathtt{(\textit{\%o}_{47})}\quad \begin{pmatrix}0 & 1 & a \\ 1 & 0 & 1 \\ 1 & 1 & 0 \\ \end{pmatrix}\cdot \left(\frac{\begin{pmatrix}-1 & a & 1 \\ 1 & -a & a \\ 1 & 1 & -1 \\ \end{pmatrix}}{a+1}\right)$$
(%i48) expand(%);$$\mathtt{(\textit{\%o}_{48})}\quad \begin{pmatrix}\frac{a}{a+1}+\frac{1}{a+1} & 0 & 0 \\ 0 & \frac{a}{a+1}+\frac{1}{a+1} & 0 \\ 0 & 0 & \frac{a}{a+1}+\frac{1}{a+1} \\ \end{pmatrix}$$
(%i49) factor(%);$$\mathtt{(\textit{\%o}_{49})}\quad \begin{pmatrix}1 & 0 & 0 \\ 0 & 1 & 0 \\ 0 & 0 & 1 \\ \end{pmatrix}$$


# If-then-else

(%i50) x: 1234;$$\mathtt{(\textit{\%o}_{50})}\quad 1234$$
(%i51) y: 2345;$$\mathtt{(\textit{\%o}_{51})}\quad 2345$$


(%i52) if x > y
  then x
  else y;$$\mathtt{(\textit{\%o}_{52})}\quad 2345$$
